/* GSI - general sound interface: gsitest, tests the gsi sound server
 *
 * main.cc
 *
 * Copyright (C) W.H.Scholten 1998
 */

#define USE_SOUND

/*__________________INCLUDES___________________*/
#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <unistd.h>

#include <math.h>

//#include "mytypes.h"

#ifdef USE_SOUND
#  include <gsi/gsi.h>
#endif

#define USE_CURSES
#ifdef USE_CURSES
#  include <ncurses/curses.h>
#endif

/*__________________VARIABELEN___________________*/
#ifdef USE_SOUND
int  snd_channels=2;
int  frag_size=8;
int  snd_type=2; //8 bit
int  dsp_speed=8000;
//#  define SOUNDDIR "/home/wouter/muziek"
#  define SOUNDDIR "./sounds"
#  define SOUNDFILE "test.sounds"
#endif


/*__________________PROGRAMMA___________________*/
int main(int argc, char *argv[]) {
	int  i, end;
	char ch;
	int  x, dx, dopplerspeed;

#ifdef USE_CURSES
	initscr();
	cbreak();
		/*noecho();*/

//	nonl(); /* no newline */
	intrflush(stdscr, FALSE);
	keypad(stdscr, TRUE);
//see man ncurses for more info on these functions
#endif

//   init_sound(8000, 2, 3, 8, SOUNDDIR, SOUNDFILE);
	frag_size = 8+snd_channels-1+(snd_type+1)/2-1;
	gsi_init();
	gsi_init_pcm(dsp_speed, snd_channels, snd_type, frag_size, SOUNDDIR, SOUNDFILE);
//	init_sound(dsp_speed, snd_channels, snd_type, frag_size, NULL, NULL);
	gsi_send_commands(1, SND_CALLBACK_ON);

	{
#define TEST2
#ifdef TEST1
		char *fdata;
		int  size;
		FILE *fp; fp=fopen("/home/wouter/muziek/110.au", "r");

		fseek(fp, 0, SEEK_END);
		size=ftell(fp);
		fdata=(char *) malloc(size);
		fseek(fp, 0, SEEK_SET);
		fread(fdata, size, 1, fp);
		gsi_send_sample(19, 11025, GSI_8BIT/*type*/, 1/*channels*/, size/*size*/, fdata/*data*/);
		free(fdata);
		fclose(fp);
#endif
#ifdef TEST2
		gsi_load_file(19, "/home/wouter/muziek/110.au");
#endif
	}

	end=0;

	do {
		ch=getchar();
		switch (ch) {
		case '1' : gsi_play_sound_flush(0,0); break;
		case '!' : gsi_play_sound_flush(10,0); break;
		case '2' : gsi_play_sound_flush(1,0); break;
		case '@' : gsi_play_sound_flush(11,0); break;
		case '3' : gsi_play_sound_flush(2,0); break;
		case '#' : gsi_play_sound_flush(12,0); break;

		case '4' : gsi_play_sound_flush(3,0); break;
		case '$' : gsi_play_sound_flush(13,0); break;

		case '5' : gsi_play_sound_flush(4,0); break;
		case '%' : gsi_play_sound_flush(14,0); break;
		case '6' : gsi_play_sound_flush(5,0); break;
		case '^' : gsi_play_sound_flush(15,0); break;
		case '7' : gsi_play_sound_flush(6,0); break;
		case '&' : gsi_play_sound_flush(16,0); break;

		case '8' : gsi_play_sound_flush(7,0); break;
		case '*' : gsi_play_sound_flush(17,0); break;

		case '9' : gsi_play_sound_flush(8,0); break;
		case '(' : gsi_play_sound_flush(18,0); break;

		case '0' : gsi_play_sound_flush(9,0); break;
		case ')' : gsi_play_sound_flush(19,0); break;

		case 'q' : gsi_kill_sounds(); break;

		case 'a' : gsi_play_sound_flush(0, SND_REPEAT); break;
		case 's' : gsi_play_sound_flush(0, SND_KILL); break;

		case 'z' : x=-64; dx=0; //left
			gsi_send_commands(5, SND_SET_X | SND_CURRENT, x &255, x >>8, SND_SET_DX | SND_CURRENT, dx); break;
		case 'x' : x=  0; dx=0; //middle
			gsi_send_commands(5, SND_SET_X | SND_CURRENT, x &255, x >>8, SND_SET_DX | SND_CURRENT, dx); break;
		case 'c' : x= 64; dx=0; //right
			gsi_send_commands(5, SND_SET_X | SND_CURRENT, x &255, x >>8, SND_SET_DX | SND_CURRENT, dx); break;
		case ',' : dx=-3;  //to left
			gsi_send_commands(2, SND_SET_DX | SND_CURRENT, dx); break;
		case '.' : dx= 3;  //to right
			gsi_send_commands(2, SND_SET_DX | SND_CURRENT, dx); break;

		case '<' : dx=-3;  //to left
			dopplerspeed=20;
			gsi_send_commands(5, SND_SET_DX | SND_CURRENT, dx, SND_SET_DOPPLER | SND_CURRENT, dopplerspeed&255, dopplerspeed >>8); break;
		case '>' : dx= 3;  //to right
			dopplerspeed=20;
			gsi_send_commands(5, SND_SET_DX | SND_CURRENT, dx, SND_SET_DOPPLER | SND_CURRENT, dopplerspeed&255, dopplerspeed >>8); break;


		case ';' : dx=-5;  //to left
			gsi_send_commands(2, SND_SET_CHANNEL_DX | SND_CURRENT, dx); break;
		case '\'': dx= 5; //to right
			gsi_send_commands(2, SND_SET_CHANNEL_DX | SND_CURRENT, dx); break;
		case '[' : dx=-5;  //to left
			gsi_send_commands(3, SND_SET_CHANNEL_DX, 5, dx); break;
		case ']' : dx= 5; //to right
			gsi_send_commands(3, SND_SET_CHANNEL_DX, 5, dx); break;


		case 'F': gsi_send_commands(2, SND_FREE_SOUND, 0);
			break;
		case 'A': gsi_send_commands(1, SND_AUTO_DSP);
			break;
		case 'G': gsi_send_commands(1, SND_GRAB_DSP);
			break;
		case 'R': gsi_send_commands(1, SND_RELEASE_DSP);
			break;
		case 'V': gsi_play_channel_sound(0, 19, SND_PLAY); break;
		case 'v': gsi_kill_channel_sound(0); break;

		case 'D': gsi_play_channel_sound(1, 0, SND_PLAY); break;
		case 'd': gsi_kill_channel_sound(1); break;

		case 'E': gsi_play_channel_sound(5, 6, SND_PLAY); break;
		case 'e': gsi_kill_channel_sound(5); break;

		case 'o': gsi_send_commands(4, SND_SET_CHANNEL_ANGLE_DEFAULT_R | SND_CURRENT, 64, SND_CHANGE_CHANNEL_VOLUME | SND_CURRENT, 220); break;
		case 'p' : gsi_send_commands(2, SND_CHANGE_CHANNEL_VOLUME | SND_CURRENT, 100); break;
		case 'U' : gsi_send_commands(2, SND_SET_CHANNEL_ANGLE_DEFAULT_R | SND_CURRENT, 192); break;
		case 'I' : gsi_send_commands(2, SND_SET_CHANNEL_ANGLE_DEFAULT_R | SND_CURRENT, 128); break;
		case 'O' : gsi_send_commands(2, SND_SET_CHANNEL_ANGLE_DEFAULT_R | SND_CURRENT, 64); break;
		case 'P' : gsi_send_commands(2, SND_SET_CHANNEL_ANGLE_DEFAULT_R | SND_CURRENT, 0); break;

		case 27  : end=1;
		default  : break;
		}
		gsi_flush();
	} while (!end);
#ifdef USE_CURSES
	nocbreak(); /* buffer IO again */
	endwin();
#endif
	gsi_close();

	return 0;
}

